#include "graph.c"

#include <stdio.h>
#include <stdlib.h>

#define _uoi_maxN 500
#define _uoi_maxStones 1000
#define _uoi_maxGraphs 200
#define _uoi_maxHistory 100

int _uoi_graphs;
int _uoi_N[_uoi_maxGraphs], _uoi_M[_uoi_maxGraphs], _uoi_currentVertex[_uoi_maxGraphs], _uoi_markedVertex[_uoi_maxGraphs], _uoi_whereToGo, _uoi_answer, _uoi_neighborsCount;
int _uoi_edges[_uoi_maxGraphs][_uoi_maxN + 1][_uoi_maxN], _uoi_edgesCount[_uoi_maxGraphs][_uoi_maxN + 1], _uoi_stones[_uoi_maxGraphs][_uoi_maxN + 1], _uoi_neighbors[_uoi_maxN];
int _uoi_final_answers[_uoi_maxGraphs], _uoi_not_answered[_uoi_maxGraphs], _uoi_not_answered_count, _uoi_history[_uoi_maxGraphs][_uoi_maxHistory][_uoi_maxN + 6], _uoi_history_count[_uoi_maxGraphs];
int _uoi_shuffled[_uoi_maxN];

int _uoi_testAndClearHistory(int g)
{
    for (int i = _uoi_history_count[g] - 1; i >= 0; i--)
    {
        int current = _uoi_history[g][i][_uoi_maxN + 2], whereToGo = -1, answer = -1;
        graph(_uoi_markedVertex[g] == 0 ? 1 : 2, _uoi_history[g][i][_uoi_maxN + 1], _uoi_history[g][i], &current, &whereToGo, &answer);
        if (current != _uoi_history[g][i][_uoi_maxN + 3] || whereToGo != _uoi_history[g][i][_uoi_maxN + 4] || answer != _uoi_history[g][i][_uoi_maxN + 5])
            return 0;
    }
    _uoi_history_count[g] = 0;
    return 1;
}

void _uoi_reshuffle(int arraySize)
{
    for (int i = 0; i < arraySize; i++)
        _uoi_shuffled[i] = i;
    for (int i = arraySize - 1; i > 0; i--)
    {
        int index = rand() % (i + 1);
        int t = _uoi_shuffled[index];
        _uoi_shuffled[index] = _uoi_shuffled[i];
        _uoi_shuffled[i] = t;
    }
}

int main()
{
    FILE* f;

    f = fopen("graph_covert_ytr.dat", "r");
    fscanf(f, "%d", &_uoi_graphs);
    for (int g = 0; g < _uoi_graphs; g++)
    {
        fscanf(f, "%d %d %d %d", &_uoi_N[g], &_uoi_M[g], &_uoi_currentVertex[g], &_uoi_markedVertex[g]);
        for (int i = 1; i <= _uoi_N[g]; i++)
        {
            _uoi_edgesCount[g][i] = 0;
            _uoi_stones[g][i] = 0;
        }
        if (_uoi_markedVertex[g] > 0)
            _uoi_stones[g][_uoi_markedVertex[g]] = 1;
        for (int i = 0; i < _uoi_M[g]; i++)
        {
            int a, b;
            fscanf(f, "%d %d", &a, &b);
            _uoi_edges[g][a][_uoi_edgesCount[g][a]] = b;
            _uoi_edgesCount[g][a]++;
            _uoi_edges[g][b][_uoi_edgesCount[g][b]] = a;
            _uoi_edgesCount[g][b]++;
        }
    }
    fclose(f);

    _uoi_not_answered_count = _uoi_graphs;
    for (int i = 0; i < _uoi_graphs; i++)
        _uoi_not_answered[i] = i;

    while (_uoi_not_answered_count > 0)
    {
        int g_index = rand() % _uoi_not_answered_count;
        int g = _uoi_not_answered[g_index];
        if (_uoi_history_count[g] == _uoi_maxHistory)
            if (! _uoi_testAndClearHistory(g))
                return 10005;
        _uoi_history[g][_uoi_history_count[g]][_uoi_maxN + 1] = _uoi_edgesCount[g][_uoi_currentVertex[g]];
        _uoi_reshuffle(_uoi_edgesCount[g][_uoi_currentVertex[g]]);
        for (int i = 0; i < _uoi_edgesCount[g][_uoi_currentVertex[g]]; i++)
            _uoi_history[g][_uoi_history_count[g]][i] = _uoi_neighbors[i] = _uoi_stones[g][_uoi_edges[g][_uoi_currentVertex[g]][_uoi_shuffled[i]]];
        _uoi_history[g][_uoi_history_count[g]][_uoi_maxN + 2] = _uoi_stones[g][_uoi_currentVertex[g]];
        _uoi_whereToGo = _uoi_answer = -1;
        graph(_uoi_markedVertex[g] == 0 ? 1 : 2, _uoi_edgesCount[g][_uoi_currentVertex[g]], _uoi_neighbors, &_uoi_stones[g][_uoi_currentVertex[g]], &_uoi_whereToGo, &_uoi_answer);
        _uoi_history[g][_uoi_history_count[g]][_uoi_maxN + 3] = _uoi_stones[g][_uoi_currentVertex[g]];
        _uoi_history[g][_uoi_history_count[g]][_uoi_maxN + 4] = _uoi_whereToGo;
        _uoi_history[g][_uoi_history_count[g]][_uoi_maxN + 5] = _uoi_answer;
        _uoi_history_count[g]++;
        if (_uoi_stones[g][_uoi_currentVertex[g]] < 0 || _uoi_stones[g][_uoi_currentVertex[g]] > _uoi_maxStones)
            return 10001;
        if (_uoi_whereToGo != -1 && _uoi_answer != -1)
            return 10002;
        if (_uoi_whereToGo == -1 && _uoi_answer == -1)
            return 10003;
        if (_uoi_answer != -1)
        {
            if (! _uoi_testAndClearHistory(g))
                return 10005;
            _uoi_final_answers[g] = _uoi_answer;
            _uoi_not_answered[g_index] = _uoi_not_answered[_uoi_not_answered_count - 1];
            _uoi_not_answered_count--;
            continue;
        }

        int found = 0;
        for (int i = 0; i < _uoi_edgesCount[g][_uoi_currentVertex[g]]; i++)
            if (_uoi_stones[g][_uoi_edges[g][_uoi_currentVertex[g]][i]] == _uoi_whereToGo)
            {
                _uoi_currentVertex[g] = _uoi_edges[g][_uoi_currentVertex[g]][i];
                found = 1;
                break;
            }
        if (found == 0)
            return 10004;
    }

    f = fopen("graph_covert_ytr.sol", "w");
    for (int i = 0; i < _uoi_graphs; i++)
        fprintf(f, "%d\n", _uoi_final_answers[i]);
    fclose(f);

    return 0;
}
